module OttomanORM
    class Datastore

        attr_accessor :client

        def initialize parameters
            self.connect parameters
        end

        def create name, data
            execute_sproc(name + '_create', data)
        end

        def get name, id
            execute_sproc(name + '_get', id).values()
        end

        def get_by_field name, field, value
            execute_sproc(name + '_get_by_' + field, value).values()
        end

        protected

            def connect parameters
                config = YAML.load_file(File.join('config', 'ottoman_orm.yml'))[parameters[:mode]]

                @client  = PG::Connection.new(
                    :host => config['host'],
                    :port => config['port'],
                    :dbname => config['dbname'],
                    :user => config['user'],
                    :password => config['password']
                )
            end; alias :reconnect! :connect

            def execute_sproc(sproc, args)
                @client.exec(build_query_string(sproc, args))
            end

            def build_query_string(sproc, args)
                query_string = 'select ' + sproc + '(\'' + args + '\')'
            end
    end
end
